package org.yaoqiang.bpmn.editor.dialog.panels;

import java.util.ArrayList;
import java.util.List;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

import org.yaoqiang.bpmn.editor.dialog.BPMNPanelContainer;
import org.yaoqiang.bpmn.editor.dialog.XMLTablePanel;
import org.yaoqiang.bpmn.editor.dialog.XMLTextPanel;
import org.yaoqiang.bpmn.editor.dialog.XMLPanel;
import org.yaoqiang.bpmn.editor.view.BPMNGraph;
import org.yaoqiang.bpmn.model.BPMNModelUtils;
import org.yaoqiang.bpmn.model.elements.artifacts.Category;
import org.yaoqiang.bpmn.model.elements.artifacts.CategoryValue;
import org.yaoqiang.bpmn.model.elements.artifacts.Group;
import org.yaoqiang.graph.util.Utils;

import com.mxgraph.model.mxCell;

/**
 * CategoryPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CategoryPanel extends XMLPanel {

	private static final long serialVersionUID = 1L;

	protected XMLPanel namePanel;

	public CategoryPanel(BPMNPanelContainer pc, Category owner) {
		super(pc, owner);
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		namePanel = new XMLTextPanel(pc, owner.get("name"));

		JPanel idNamePanel = new JPanel();
		idNamePanel.setLayout(new BoxLayout(idNamePanel, BoxLayout.X_AXIS));
		idNamePanel.add(new XMLTextPanel(pc, owner.get("id"), false));
		idNamePanel.add(Box.createHorizontalGlue());
		idNamePanel.add(namePanel);
		this.add(idNamePanel);

		List<String> columnsToShow = new ArrayList<String>();
		columnsToShow.add("id");
		columnsToShow.add("value");
		this.add(new XMLTablePanel(getPanelContainer(), owner.getCategoryValues(), "", "categoryValues", columnsToShow, owner.getCategoryValueList(), 350, 150, true,
				false));
	}

	public void saveObjects() {
		String oldValue = ((Category) owner).getName();
		namePanel.saveObjects();
		String newValue = ((Category) owner).getName();

		if (!oldValue.equals(newValue)) {
			BPMNGraph graph = getGraphComponent().getGraph();
			for (mxCell group : Utils.getAllGroups(graph)) {
				Group groupElement = (Group) graph.getBpmnElementMap().get(group.getId());
				String categoryValueId = groupElement.getCategoryValueRef();
				if (BPMNModelUtils.getAllCategoryValueIds((Category) owner).contains(categoryValueId)) {
					CategoryValue categoryValue = ((Category) owner).getCategoryValue(categoryValueId);
					if (newValue.length() == 0) {
						group.setValue(categoryValue.getValue());
					} else {
						group.setValue(newValue + ":" + categoryValue.getValue());
					}
				}
			}
			graph.refresh();
		}
		super.saveObjects();
	}

}
