package org.yaoqiang.bpmn.model.elements;

import java.util.List;
import java.util.Map.Entry;

import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;


/**
 * XMLTextElements
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class XMLTextElements extends XMLCollection {

	protected String textElement = "";
	
	public XMLTextElements(XMLComplexElement parent, String name) {
		super(parent, name);
		this.textElement = name;
	}

	public XMLElement generateNewElement() {
		return new XMLTextElement(this, textElement);
	}

	public void addValues(List<XMLElement> values) {
		if (values != null && values.size() > 0) {
			for (XMLElement value : values) {
				XMLElement el =  generateNewElement();
				if (value instanceof BaseElement) {
					el.setValue(((BaseElement) value).getId());
				} else {
					el.setValue(value.toValue());
				}
				add(el);
			}
		}
	}
	
	public void add(XMLElement el) {
		if (el == null) {
			return;
		}
		elements.put(el.toValue(), el);
	}
	
	public XMLElement remove(String value) {
		for(Entry<String, XMLElement> e :elements.entrySet()) {
			if (e.getKey().equals(value)) {
				return elements.remove(e.getKey());
			}
		}
		return null;
	}
	
	public String getElementName() {
		return textElement;
	}
	
}
