package org.yaoqiang.bpmn.model.elements.artifacts;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLTextElement;

/**
 * TextAnnotation
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class TextAnnotation extends Artifact {

	public TextAnnotation(Artifacts parent) {
		super(parent, "textAnnotation");
	}

	protected void fillStructure() {
		XMLAttribute attrTextFormat = new XMLAttribute(this, "textFormat", "text/plain");
		XMLTextElement refText = new XMLTextElement(this, "text");

		super.fillStructure();
		add(attrTextFormat);
		add(refText);
	}

	public Artifacts getParent() {
		return (Artifacts) parent;
	}

	public final String getText() {
		return get("text").toValue();
	}

	public final void setText(String text) {
		set("text", text);
	}

}
