package org.yaoqiang.bpmn.model.elements.conversations;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLFactory;

/**
 * Conversations
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ConversationNodes extends XMLFactory {

	public static final String TYPE_CONVERSATION = "conversation";
	public static final String TYPE_CALL_CONVERSATION = "callConversation";
	public static final String TYPE_SUBCONVERSATION = "subConversation";
	
	public ConversationNodes(XMLElement parent) {
		super(parent, "conversationNodes");
	}

	public XMLElement generateNewElement() {
		if (type.equals(TYPE_CONVERSATION)) {
			return new Conversation(this);
		} else if (type.equals(TYPE_CALL_CONVERSATION)) {
			return new CallConversation(this);
		} else if (type.equals(TYPE_SUBCONVERSATION)) {
			return new SubConversation(this);
		}
		return null;
	}
	
}
