package org.yaoqiang.bpmn.model.elements.core.common;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.RootElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.RootElements;

/**
 * Resource
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Resource extends BaseElement implements RootElement {

	public Resource(RootElements parent) {
		super(parent, "resource");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		ResourceParameters refResourceParameters = new ResourceParameters(this);

		super.fillStructure();
		add(attrName);
		add(refResourceParameters);
	}
	
	public final String getName() {
		return get("name").toValue();
	}
	
	public final ResourceParameter getResourceParameter(String parameterId) {
		return (ResourceParameter) getResourceParameters().getCollectionElement(parameterId);
	}
	
	public final ResourceParameters getResourceParameters() {
		return (ResourceParameters) get("resourceParameters");
	}

	public final List<XMLElement> getResourceParameterList() {
		return getResourceParameters().getXMLElements();
	}
	
}
