package org.yaoqiang.bpmn.model.elements.events;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.core.common.Expression;

/**
 * ConditionalEventDefinition
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ConditionalEventDefinition extends EventDefinition {

	public ConditionalEventDefinition(XMLElement parent) {
		super(parent, "conditionalEventDefinition");
	}

	protected void fillStructure() {
		Expression refExpression = new Expression(this, "condition");

		super.fillStructure();
		add(refExpression);
	}
	
	public final String getConditionString() {
		return getConditionExpression().toValue();
	}
	
	public final Expression getConditionExpression() {
		return (Expression) get("condition");
	}
	
	public final void setConditionExpression(String expression) {
		getConditionExpression().setValue(expression);
	}
	
}
