package org.yaoqiang.bpmn.model.elements.events;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;

/**
 * LinkEventDefinition
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class LinkEventDefinition extends EventDefinition {

	public LinkEventDefinition(XMLElement parent) {
		super(parent, "linkEventDefinition");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLTextElements refSources = new XMLTextElements(this, "source");
		XMLTextElement refTarget = new XMLTextElement(this, "target");

		super.fillStructure();
		add(attrName);
		add(refSources);
		add(refTarget);
	}

	public final String getName() {
		return get("name").toValue();
	}

	public final String getTarget() {
		return get("target").toValue();
	}

	public final XMLTextElements getSources() {
		return (XMLTextElements) get("source");
	}
	
	public final List<XMLElement> getSourceList() {
		return getSources().getXMLElements();
	}
	
	public final void setName(String name) {
		set("name", name);
	}
	
	public final void setTarget(String target) {
		set("target", target);
	}
	
}
