package org.yaoqiang.graph.editor.dialog;

import org.yaoqiang.graph.editor.dialog.panels.DefaultSettingsPanel;
import org.yaoqiang.graph.editor.dialog.panels.ElementStylesPanel;

/**
 * PanelFactory
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class PanelFactory {

	protected PanelContainer panelContainer;

	public PanelFactory(PanelContainer pc) {
		this.panelContainer = pc;
	}

	public Panel getPanel(Object el, String type) {
		if (el == null) {
			if ("elementStyles".equals(type)) {
				return new ElementStylesPanel(panelContainer, el);
			} else if ("defaultSettings".equals(type)) {
				return new DefaultSettingsPanel(panelContainer, el);
			}
		}
		return null;
	}

}
